<template>
  <div class="input-form q-mb-lg">
    <div v-if="isToggleNeeded()" class="input-form__first-line full-width">
      <RadioToggleComponent
        :indicatorType="indicator"
        :isFetching="isFetching"
        v-model="localModel.toggleSelectedValue"
      />
    </div>

    <div class="input-form__indicator-dynamic-description q-mb-md">
      <p><slot /></p>
    </div>

    <div class="input-form__second-line full-width q-mb-md">
      <div v-if="isSingleSelectorNeeded()" class="single-picker">
        <SingleChoiceSelectorComponent
          v-model="localModel.singleChoiseSelectedValue"
          :indicatorType="indicator"
          :isFetching="isFetching"
        />
      </div>
      <div class="single-picker q-mb-lg">
        <MultipleChoiceSelectorComponent
          v-if="isProvinceSelectorNeeded()"
          v-model="localModel.provinciasSelectedValues"
          :isFetching="isFetching"
        />
      </div>
    </div>

    <div class="input-form__third-line full-width">
      <div class="single-picker">
        <DatePickerComponent
          v-model="localModel.userDateRangeQuery.userDateQueryStart"
          :isFetching="isFetching"
          :isDateRangeValid="isDateRangeValid"
          :startPossibleYearOfPeriod=2013
          errorMessage="La fecha de Inicio del período debe ser anterior a la fecha de finalización del período"
          selectorLabel="Fecha inicio"
        />
      </div>

      <div class="single-picker">
        <DatePickerComponent
          v-model="localModel.userDateRangeQuery.userDateQueryEnd"
          :isFetching="isFetching"
          :isDateRangeValid="isDateRangeValid"
          :startPossibleYearOfPeriod=2013
          errorMessage="La fecha fin del período debe ser posterior a la fecha de inicio del período"
          selectorLabel="Fecha fin"
        />
      </div>
    </div>
  </div>
</template>

<script setup>
import { computed, ref, watchEffect } from 'vue';
import RadioToggleComponent from './radio-toggle-component/RadioToggleComponent.vue';
import SingleChoiceSelectorComponent from './single-choice-selector-component/SingleChoiceSelectorComponent.vue';
import MultipleChoiceSelectorComponent from './multiple-choice-component/MultipleChoiceSelectorComponent.vue';
import DatePickerComponent from './date-picker-component/DatePickerComponent.vue';

const props = defineProps({
  indicator:              { type: String, required: true },
  modelValue:             { type: Object, required: true },
  isFetching:             { type: Boolean, required: true },
});

const emit = defineEmits(['update:modelValue'])

const localModel = computed({
  get: () => props?.modelValue,
  set: (value) => {
    emit("update:modelValue", value)
  },
})

const isDateRangeValid = ref(true)

const isToggleNeeded = () =>
  [   'indicator_1_2',
      'indicator_3_4',
      'indicator_5_6',
      'indicator_7_8',
      'indicator_10_11'].includes(props.indicator);

const isSingleSelectorNeeded = () =>
  ![  'indicator_5_6',
      'indicator_12',
      'indicator_13'].includes(props.indicator);

const isProvinceSelectorNeeded = () =>
  ![  'indicator_16',
      'indicator_17'].includes(props.indicator);

const checkDateRangeValid = function() {
  const startDateObject = new Date(localModel.value.userDateRangeQuery.userDateQueryStart.pickedYear, localModel.value.userDateRangeQuery.userDateQueryStart.pickedMonth, 1, 0, 0, 0, 0);
  const endDateObject = new Date(localModel.value.userDateRangeQuery.userDateQueryEnd.pickedYear, localModel.value.userDateRangeQuery.userDateQueryEnd.pickedMonth + 1, 0, 0, 0, 0, 0);
  isDateRangeValid.value = startDateObject <= endDateObject;
};

const validateDataModel = function () {
  checkDateRangeValid();
  if (['indicator_16', 'indicator_17'].includes(props.indicator)) {
    localModel.value.isUserQueryValid = isDateRangeValid.value;
  } else {
    localModel.value.isUserQueryValid = isDateRangeValid.value && localModel.value.provinciasSelectedValues.length > 0;
  }
};

watchEffect(() => {
  validateDataModel();
});

</script>

<style lang="scss" scoped>
@use './inputs-component-stylesheet.scss';
</style>